pfSense - Feature #7193

NTP process PGRMF
02/02/2017 02:42 AM - Jack Booth

Status: Resolved Start date: 02/02/2017
Priority: Normal Due date:

Assignee: Jack Booth % Done: 0%
Category: NTPD Estimated time: 0.00 hour
Target version: 2.4.0

Plus Target Version: Release Notes:

Description

The Garmin only NMEA sentence PGRMF can be used by NTP as the time sync. Unlike the other NMEA sentences PGRMF
includes leap second information that can be enabled in the NTP driver via the mode.

History

#1 - 02/02/2017 02:45 AM - Jack Booth

PR https://github.com/pfsense/pfsense/pull/3463

#2 - 02/07/2017 06:33 PM - Jim Thompson

- Assignee set to Jim Pingle

#3 - 02/07/2017 06:33 PM - Jim Thompson
- Category set to NTPD

#4 - 02/07/2017 07:01 PM - Jim Pingle
- Status changed from New to Feedback
- Assignee changed from Jim Pingle to Jack Booth

- Target version set to 2.4.0

PR merged

#5 - 02/28/2017 03:33 PM - Par Wedin

| have the hardware to test this and | have enabled the "Process PGRMF" option, but | don't know what to look for. Can you give me a hint?
#6 - 03/01/2017 04:25 AM - Jack Booth
Par Wedin wrote:

| have the hardware to test this and | have enabled the "Process PGRMF" option, but | don't know what to look for. Can you give me a hint?
If you have set the GPS to output PGRMF and have the option enabled you should be able to check the clockvar using 'ntpq -c cv' after ntpd has
settled on the GPS device and see it used PGRMF in the timecode field. If the GPS is not the selected peer you need to check the clockvar of the
correct association id, run 'ntpq -c ap' you should get something similar to:

remote refid assid st t when poll reach delay offset jitter

+GPS_NMEA(0) .GPS. 123450112 16 377 0.000 0.000 0.001

Then run 'ntpq -¢ "cv 12345™ and check the timecode field.

#7 - 03/01/2017 03:15 PM - Par Wedin
In my original config | had GPGGA and PGRMF enabled and it seems that it prefers GPGGA then:

associd=30382 status=0012 1 event, clk_bad_format,
https://github.com/pfsense/pfsense/pull/3463

device="NMEA GPS Clock",
timecode="$GPGGA,183336,5854.4236,N,01756.9851,E,2,06,1.8,43.5,M,23.1,M,,*7F",
poll=230, noreply=0, badformat=1, baddata=0, fudgetime2=700.000,

stratum=0, refid=GPS, flags=5

From /var/etc/ntp.conf:

# GPS Setup
server 127.127.20.0 mode 258 minpoll 4 maxpoll 4 prefer
fudge 127.127.20.0 time2 0.700 flagl 1 flag3 1

However, choosing all NMEA sentences plus PGRMF resulted in:

associd=13378 status=0042 4 events, clk_bad_format,

device="NMEA GPS Clock",

timecode="$PGRMF, 914,335618,010317,211320,18,5854.4278,N,01757.0052,E,A,2,0,206,1,1*10",
poll=440, noreply=1, badformat=3, baddata=0, fudgetime2=1675.000,

stratum=0, refid=GPS, flags=5

Current /var/etc/ntp.conf includes:

# GPS Setup
server 127.127.20.0 mode 256 minpoll 4 maxpoll 4 prefer
fudge 127.127.20.0 time2 1.675 flagl 1 flag3 1

| also had to change the fudge time2 with an extra second as the GPS source was exactly one second off for some reason.

| have a Supermicro A1SRi-2558F board with 8 GB of memory. The Garmin GPS 18x LVC is connected to cuaul. The pfSense build is from Mon Feb
27 02:08:42 CST 2017. | updated it to the new build this morning and | lost the connection to the gps as a result. The only way to get it back on was to
roll back to the Feb 27 build, then it worked without a problem.

If you want me to run some more test then I'm happy to do so.

#8 - 03/18/2017 10:29 PM - Jack Booth

| also have a Garmin 18x LVC and I've been trying to replicate your setup but I'm not really sure why you needed a fudge time2 that high. What init
commands are you using? Are you sure you are only getting GPGGA and PGRMF? You could try "cat /dev/cuaul" to confirm. I'm currently running
2.3.3p1 and seemed to have no issue with

# GPS Setup
server 127.127.20.0 mode 256 minpoll 4 maxpoll 4 prefer
fudge 127.127.20.0 time2 0.535 flagl 1 flag3 1

You could possibly try a different baud rate like 9600 but I'm not sure why you would need that if you have only set GPGGA and PGRMF.

#9 - 03/22/2017 01:04 PM - Par Wedin

I'm sorry, | think | was unclear. In my original config | had selected GGA in the “NMEA Sentences” menu, plus ticked off “Process PGRMF” on the
“Services/NTP/Serial GPS” page. That's when it seemed to select the $GPGGA sentence. But when | selected “All” in the “NMEA Sentences” menu,
$PGRMF was selected.

In the configuration software for the gps | had selected GPGGA, GPGSA, GPGSV, GPRMC and PGRMF and 4800 baud. If | do “cat /dev/cuaul” | can
see those sentences. To see what the issue might be | have tested that particular gps on two systems.

On the Supermicro A1SRi-2558F I'm now running 2.3.3-p1 and | get the following offset when using $PGRMF at different baud rates:

Baud rate SPGRMF offset

I
__________ e
4800 | -1679
9600 | -879
19200 | -639
38400 | -517

On a Gigabyte Celeron J1900 system running 2.4.0-20170318 | get the following offsets for SPGRMF at different baud rates:

Baud rate SPGRMF offset

I
__________ e
4800 | -1346
9600 | -1016
19200 | -612
38400 | -503
Clearly the offset becomes smaller as baud-rates increases but they are still large. Maybe | have a dodgy gps receiver.

#10 - 09/15/2017 02:43 PM - Jim Pingle

- Status changed from Feedback to Resolved

PR was merged, seems to be OK but not possible to confirm at the moment. If it is not working, someone can reply here and we can reopen the ticket
later.
